"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.normalizedCreateNodesContext = normalizedCreateNodesContext;
const promises_1 = require("node:fs/promises");
const path = require("node:path");
const constants_js_1 = require("./constants.js");
async function normalizedCreateNodesContext(context, projectConfigurationFile, createOptions = {}) {
    const projectRoot = path.dirname(projectConfigurationFile);
    try {
        const projectJson = JSON.parse((await (0, promises_1.readFile)(projectConfigurationFile)).toString());
        const { targetName = constants_js_1.CP_TARGET_NAME } = createOptions;
        return {
            ...context,
            projectJson,
            projectRoot,
            createOptions: {
                ...createOptions,
                targetName,
            },
        };
    }
    catch {
        throw new Error(`Error parsing project.json file ${projectConfigurationFile}.`);
    }
}
//# sourceMappingURL=utils.js.map